//+------------------------------------------------------------------+
//|                                                  TrendRSI_v3.mq4 |
//|                          Typical RSI revised By TrendLaboratory  |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                       E-mail: igorad2004@list.ru |
//|                    mrtools modified the original rsi calculation |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Silver
#property indicator_color2 LimeGreen
#property indicator_color3 Orange

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame       = PERIOD_CURRENT;
extern int                StochasticPeriod  = 14;
extern int                StochasticSlowing = 3;
extern ENUM_STO_PRICE     Price           = 0;
extern int    EMAPeriod       = 5;
extern int    ATRPeriod       = 14;
extern double K               = 2.618;
extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern bool   alertsNotify    = false;
extern string soundfile       = "alert2.wav";
extern bool   DotsOnFirst     = false;

extern double levelOb         = 70;
extern double levelOs         = 30;

extern bool   Interpolate     = true;


//
//
//
//
//

double RSIindex[];
double UpTrend[];
double DnTrend[];
double rsi[];
double smin[];
double smax[];
double trend[];

string indicatorFileName;
bool   returnBars;

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int init()
  {
   IndicatorBuffers(7);
   SetIndexBuffer(0,RSIindex);                                                  SetIndexLabel(0,"TrendRSI");
   SetIndexBuffer(1,UpTrend); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159);SetIndexLabel(1,"UpTrend"); 
   SetIndexBuffer(2,DnTrend); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,159);SetIndexLabel(2,"DownTrend"); 
   SetIndexBuffer(3,rsi);
   SetIndexBuffer(4,smin);
   SetIndexBuffer(5,smax);
   SetIndexBuffer(6,trend);
   
       //
       //
       //
       //
       //
         
        indicatorFileName = WindowExpertName();
        returnBars        = TimeFrame==-99;
        TimeFrame         = MathMax(TimeFrame,_Period);

       //
       //
       //
       //   
       //
          
   SetLevelValue(0,levelOb);
   SetLevelValue(1,levelOs);
   IndicatorShortName(timeFrameToString(TimeFrame)+"  TrendStochastic ("+StochasticPeriod+","+EMAPeriod+","+ATRPeriod+","+DoubleToStr(K,3)+")");
  return(0);
}
int deinit() { return(0); }

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { RSIindex[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame == Period())
   {
     for (i=limit; i>=0; i--) rsi[i] = iStochastic(NULL,0,StochasticPeriod,1,StochasticSlowing,MODE_SMA,Price,MODE_MAIN,i);
     for (i=limit; i>=0; i--)
     {  
        RSIindex[i] = RSIindex[i+1]+2.0/(1.0+EMAPeriod)*(rsi[i]-RSIindex[i+1]);
        double AvgRange = 0; for (int k=0; k<ATRPeriod-1; k++) AvgRange += MathAbs(RSIindex[i+k]-RSIindex[i+k+1]); 
        double range    = AvgRange/ATRPeriod;
	     smax[i]    = RSIindex[i]+K*range; 
	     smin[i]    = RSIindex[i]-K*range;
		  UpTrend[i] = EMPTY_VALUE;
        DnTrend[i] = EMPTY_VALUE;
	     trend[i]   = trend[i+1]; 
	   
	     //
	     //
	     //
	     //
	     //
	   
	     if (RSIindex[i]>smax[i+1]) trend[i] = 1; 
	     if (RSIindex[i]<smin[i+1]) trend[i] =-1;

        if (trend[i]>0 && smin[i]<smin[i+1]) smin[i] = smin[i+1];
        if (trend[i]<0 && smax[i]>smax[i+1]) smax[i] = smax[i+1];
        if (trend[i] == 1) UpTrend[i] = smin[i]; 
	     if (trend[i] ==-1) DnTrend[i] = smax[i]; 
     }
     manageAlerts(); 
     return(0);
   }
   
   //
   //
   //
   //
   //
   
   int displace = -1; if (DotsOnFirst) displace = 1;
     limit = MathMax(limit,MathMin(Bars,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
     for (i=limit;i>=0; i--)
     {
        int y = iBarShift(NULL,TimeFrame,Time[i]);
        int x = iBarShift(NULL,TimeFrame,Time[i+displace]);
         RSIindex[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,StochasticPeriod,StochasticSlowing,Price,EMAPeriod,ATRPeriod,K,"",alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,soundfile,0,y);
         UpTrend[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,StochasticPeriod,StochasticSlowing,Price,EMAPeriod,ATRPeriod,K,"",alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,soundfile,1,y);
         DnTrend[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,StochasticPeriod,StochasticSlowing,Price,EMAPeriod,ATRPeriod,K,"",alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,soundfile,2,y);
         trend[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,StochasticPeriod,StochasticSlowing,Price,EMAPeriod,ATRPeriod,K,"",alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,soundfile,6,y);
               
                     //
                     //
                     //
                     //
                     //
                        
                     if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

                     //
                     //
                     //
                     //
                     //

                     datetime time = iTime(NULL,TimeFrame,y);
                        for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
                        for(    k = 1; k < n; k++)
                        {
                           RSIindex[i+k] = RSIindex[i] + (RSIindex[i+n]-RSIindex[i])*k/n;
                           if (UpTrend[i+n]!=EMPTY_VALUE && UpTrend[i]!=EMPTY_VALUE) UpTrend[i+k]  = UpTrend[i]  + (UpTrend[i+n] -UpTrend[i] )*k/n;
                           if (DnTrend[i+n]!=EMPTY_VALUE && DnTrend[i]!=EMPTY_VALUE) DnTrend[i+k]  = DnTrend[i]  + (DnTrend[i+n] -DnTrend[i] )*k/n;
                        }
   }
return(0);
}


//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up trend");
         if (trend[whichBar] ==-1) doAlert(whichBar,"down trend");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(_Period)+" TrendStochatic ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," TrendStochatic " +" "+message));
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," TrendStochatic "),message);
          if (alertsSound)   PlaySound(soundfile);
   }
}


